<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::any('viewer_test', function () {
  \Stimulsoft\StiLicense::setPrimaryKey(file_get_contents(resource_path('reports/license/license.key')));

  $viewer = new \Stimulsoft\Viewer\StiViewer();
  $viewer->javascript->relativePath = '../';

  $viewer->onPrepareVariables = function (\Stimulsoft\Events\StiVariablesEventArgs $args) {
    //do something
  };
  
  $viewer->onBeginProcessData = function(\Stimulsoft\Events\StiDataEventArgs $args) 
  {
    switch ($args->dataSource)
    {
      case "users":
        $query = \App\Models\User::where('id', '>', 0);
        break;
    }
      
    $args->queryString = $query->toRawSql();
  };

  $viewer->onEndProcessData = function(\Stimulsoft\Events\StiDataEventArgs $args)
  {
    //do something
  };

  $viewer->process();

  $report = new Stimulsoft\Report\StiReport();
  $report->process();
  $report->load(file_get_contents(resource_path('reports/users.mrt')));

  $viewer->report = $report;

  $viewer->printHtml();
});

Route::any('print_test', function () {
  \Stimulsoft\StiLicense::setPrimaryKey(file_get_contents(resource_path('reports/license/license.key')));

  $report = new \Stimulsoft\Report\StiReport();
  $report->javascript->relativePath = '../';

  $report->onPrepareVariables = function (\Stimulsoft\Events\StiVariablesEventArgs $args) {
    //do something
  };
  
  $report->onBeginProcessData = function(\Stimulsoft\Events\StiDataEventArgs $args) 
  {
    switch ($args->dataSource)
    {
      case "users":
        $query = \App\Models\User::where('id', '>', 0);
        break;
    }
      
    $args->queryString = $query->toRawSql();
  };

  $report->onEndProcessData = function(\Stimulsoft\Events\StiDataEventArgs $args)
  {
    //do something
  };

  $report->process();
  $report->load(file_get_contents(resource_path('reports/users.mrt')));

  $report->render();
  $report->print();
  $report->printHtml();
});

Route::any('pdf_test', function () {
  \Stimulsoft\StiLicense::setPrimaryKey(file_get_contents(resource_path('reports/license/license.key')));

  $nodejs = new \Stimulsoft\StiNodeJs();
  $nodejs->binDirectory = dirname(config('node.path')); //c:\program files\nodejs

  /*$result = $nodejs->installNodeJS();
  if ($result)
    $result = $nodejs->updatePackages();*/

  $report = new \Stimulsoft\Report\StiReport();
  $report->javascript->relativePath = '../';
  $report->engine = \Stimulsoft\Report\Enums\StiEngineType::ServerNodeJS;
  $report->node = $nodejs; //is that necessary?

  $report->onPrepareVariables = function (\Stimulsoft\Events\StiVariablesEventArgs $args) {
    //do something
  };
  
  $report->onBeginProcessData = function(\Stimulsoft\Events\StiDataEventArgs $args) 
  {
    switch ($args->dataSource)
    {
      case "users":
        $query = \App\Models\User::where('id', '>', 0);
        break;
    }
      
    $args->queryString = $query->toRawSql();
  };

  $report->onEndProcessData = function(\Stimulsoft\Events\StiDataEventArgs $args)
  {
    //do something
  };

  $report->process();
  $report->load(file_get_contents(resource_path('reports/users.mrt')));

  $result = $report->render();
  
  dd($report->nodejs->errorStack, $report->nodejs->error);
  if ($result) {
    // After successfully building a report, calling the document export method. Export is also performed using Node.js engine
    // This method will return the byte data of the exported document, or save it to a file
    $filename = Storage::disk('private')->path(Host::getCurrentHostName()."/tmp/Pedido_30.pdf");
    $result = $report->exportDocument(\Stimulsoft\Export\Enums\StiExportFormat::Pdf, null, false, $filename);

    if ($result !== false) {
        $bytes = strlen($result);
        $message = "The exported document takes $bytes bytes in $filename.";
    }
    else {
        // If there is a export error, you can display the error text
        $message = $report->nodejs->error;
    }
  }
  else {
      // If there is a build error, you can display the error text
      $message = $report->nodejs->error;
  }

  echo $message;
 
});

Route::get('prueba_install', function () {
  $nodejs = new \Stimulsoft\StiNodeJs();

  $result = $nodejs->installNodeJS();
  if ($result)
    $result = $nodejs->updatePackages();


  $message = $result ? 'The installation was successful.' : $nodejs->error;
  echo $message;

  dd($nodejs);
});

Route::any('prueba_pdf3', function () {
  \Stimulsoft\StiLicense::setPrimaryKey(file_get_contents(resource_path('reports/license/license.key')));

  $nodejs = new \Stimulsoft\StiNodeJs();
  $nodejs->binDirectory = dirname(config('node.path'));


  /*$result = $nodejs->installNodeJS();
  if ($result)
    $result = $nodejs->updatePackages();*/

  $report = new \Stimulsoft\Report\StiReport();
  $report->engine = \Stimulsoft\Report\Enums\StiEngineType::ServerNodeJS;
  $report->node = $nodejs;

  $report->onPrepareVariables = function (\Stimulsoft\Events\StiVariablesEventArgs $args) {

  };
  
  $report->onBeginProcessData = function(\Stimulsoft\Events\StiDataEventArgs $args) 
  {
    $args->connectionString = \App\Models\Host::getCurrentConnectionString();

    switch ($args->dataSource)
    {
      case "users":
        $query = \App\Models\User::where('id', '>', 0);
        break;
    }
      
    $args->queryString = $query->toRawSql();
  };

  $report->onEndProcessData = function(\Stimulsoft\Events\StiDataEventArgs $args)
  {
    
  };

  $report->process();
  $report->load(file_get_contents(resource_path('reports/users.mrt')));

  $result = $report->render();
  
  dd($report->nodejs->errorStack, $report->nodejs->error);
  if ($result) {
    // After successfully building a report, calling the document export method. Export is also performed using Node.js engine
    // This method will return the byte data of the exported document, or save it to a file
    $filename = Storage::disk('private')->path(Host::getCurrentHostName()."/tmp/Users.pdf");
    $result = $report->exportDocument(\Stimulsoft\Export\Enums\StiExportFormat::Pdf, null, false, $filename);

    if ($result !== false) {
        $bytes = strlen($result);
        $message = "The exported document takes $bytes bytes in $filename.";
    }
    else {
        // If there is a export error, you can display the error text
        $message = $report->nodejs->error;
    }
  }
  else {
      // If there is a build error, you can display the error text
      $message = $report->nodejs->error;
  }

  echo $message;
 
});

Route::get('prueba_install', function () {
  $nodejs = new \Stimulsoft\StiNodeJs();

  $result = $nodejs->installNodeJS();
  if ($result)
    $result = $nodejs->updatePackages();


  $message = $result ? 'The installation was successful.' : $nodejs->error;
  echo $message;

  dd($nodejs);
});